import { defineComponent as w, reactive as k, watch as v, ref as y, onMounted as F, resolveComponent as l, openBlock as _, createElementBlock as b, createElementVNode as m, toDisplayString as D, createVNode as u, createCommentVNode as S, withCtx as h, createBlock as C } from "vue";
import { h as R, f as Z, _ as I } from "./index.ea91dc65.js";
const $ = w({
  name: "SanZhiFormRenderOa",
  props: {
    business: {
      type: [Object],
      default: () => ({})
    },
    hasHeader: {
      type: [Boolean],
      default: !0
    }
  },
  emits: ["handleBtn", "handleInfo"],
  setup(n, { emit: r }) {
    const e = k({
      params: {},
      business: {},
      workflow: {},
      formConfig: {},
      formData: {},
      loading: !1
    });
    v(
      () => n.business,
      (o) => {
        for (let t in o) {
          const a = o[t];
          if (e.business[t] !== a) {
            e.business = { ...n.business }, i();
            return;
          }
        }
      },
      { deep: !0 }
    );
    function d(o) {
      e.loading = !0, Z("apis").getFormData(o).then((t) => {
        const { data: a } = t;
        e.workflow = a || {}, e.formConfig = a.form || {}, e.formData = a.formData || {}, r("handleInfo", a);
      }).finally(() => {
        e.loading = !1;
      });
    }
    const f = y(null);
    async function c() {
      try {
        return await f.value.getFormData();
      } catch (o) {
        return console.log(o), {};
      }
    }
    async function s(o) {
      const t = await c();
      r("handleBtn", { button: o, formData: t });
    }
    function i() {
      const { flowId: o, taskId: t, instanceId: a } = n.business, p = R(), g = {
        flowId: o || p.flowId,
        taskId: t || p.taskId,
        instanceId: a || p.instanceId
      };
      e.params = g, d(g);
    }
    return F(() => {
      i();
    }), { state: e, preFormRef: f, getFormData: c, handleBtn: s };
  }
});
const A = { class: "form-render-oa" }, B = {
  key: 0,
  class: "header"
}, O = { class: "title" }, W = { class: "actions-box" }, H = { class: "oa-main" }, j = { class: "main-content" };
function N(n, r, e, d, f, c) {
  const s = l("SanZhiWorkflowActions"), i = l("SanZhiFormRender"), o = l("a-spin");
  return _(), b("div", A, [
    n.hasHeader ? (_(), b("div", B, [
      m("div", O, D(n.state.formConfig.name), 1),
      m("div", W, [
        u(s, {
          business: n.state.params
        }, null, 8, ["business"])
      ])
    ])) : S("", !0),
    m("div", H, [
      u(o, {
        spinning: n.state.loading
      }, {
        default: h(() => [
          m("div", j, [
            u(i, {
              ref: "preFormRef",
              "form-json": n.state.formConfig,
              "form-data": n.state.formData
            }, null, 8, ["form-json", "form-data"])
          ])
        ]),
        _: 1
      }, 8, ["spinning"])
    ])
  ]);
}
const V = /* @__PURE__ */ I($, [["render", N], ["__scopeId", "data-v-e43237c5"]]), E = w({
  name: "WorkflowFormRenderModal",
  components: { SanZhiFormRenderOA: V },
  props: {},
  emits: ["update:open", "handleOk", "register"],
  setup(n, { emit: r }) {
    const e = k({
      open: !1,
      business: {},
      workflow: {},
      formConfig: {}
    });
    function d(s) {
      const { flowId: i, taskId: o, announcementId: t, officialRegisterId: a } = s;
      e.business = { flowId: i, taskId: o, announcementId: t, officialRegisterId: a }, e.business.key = new Date().getTime(), e.open = !0;
    }
    function f(s) {
      e.workflow = s, e.formConfig = s.form || {};
    }
    function c() {
    }
    return r("register", { handleOpen: d }), { handleOpen: d, handleInfo: f, handleBtn: c, state: e };
  }
}), M = { class: "actions-box" };
function Q(n, r, e, d, f, c) {
  const s = l("SanZhiWorkflowActions"), i = l("SanZhiFormRenderOA"), o = l("a-drawer");
  return _(), C(o, {
    width: "100%",
    bodyStyle: { padding: "0" },
    visible: n.state.open,
    "onUpdate:visible": r[0] || (r[0] = (t) => n.state.open = t),
    title: n.state.formConfig.name
  }, {
    extra: h(() => [
      m("div", M, [
        u(s, {
          business: n.state.business
        }, null, 8, ["business"])
      ])
    ]),
    default: h(() => [
      u(i, {
        business: n.state.business,
        hasHeader: !1,
        onHandleInfo: n.handleInfo
      }, null, 8, ["business", "onHandleInfo"])
    ]),
    _: 1
  }, 8, ["visible", "title"]);
}
const U = /* @__PURE__ */ I(E, [["render", Q]]);
export {
  U as W
};
